--- orig/generator.c	2005-09-29 18:03:00
+++ generator.c	2005-10-14 19:50:15
@@ -61,6 +61,7 @@ extern int csum_length;
 extern int ignore_times;
 extern int size_only;
 extern OFF_T max_size;
+extern OFF_T min_size;
 extern int io_error;
 extern int allowed_lull;
 extern int sock_f_out;
@@ -872,6 +873,15 @@ static void recv_generator(char *fname, 
 		}
 		return;
 	}
+	if (min_size && file->length < min_size) {
+		if (verbose > 1) {
+			if (the_file_list->count == 1)
+				fname = f_name(file);
+			rprintf(FINFO, "%s is under min-size\n",
+				safe_fname(fname));
+		}
+		return;
+	}
 
 	if (ignore_existing && statret == 0) {
 		if (verbose > 1)
@@ -1265,7 +1275,7 @@ void generate_files(int f_out, struct fi
 
 	phase++;
 	csum_length = SUM_LENGTH;
-	max_size = ignore_existing = ignore_non_existing = 0;
+	max_size = min_size = ignore_existing = ignore_non_existing = 0;
 	update_only = always_checksum = size_only = 0;
 	ignore_times = 1;
 	if (append_mode)  /* resend w/o append mode */
--- orig/options.c	2005-10-14 19:47:07
+++ options.c	2005-10-14 19:08:38
@@ -99,6 +99,7 @@ int ignore_non_existing = 0;
 int need_messages_from_generator = 0;
 int max_delete = 0;
 OFF_T max_size = 0;
+OFF_T min_size = 0;
 int ignore_errors = 0;
 int modify_window = 0;
 int blocking_io = -1;
@@ -167,7 +168,7 @@ static int itemize_changes = 0;
 static int refused_delete, refused_archive_part;
 static int refused_partial, refused_progress, refused_delete_before;
 static int refused_inplace;
-static char *max_size_arg;
+static char *max_size_arg, *min_size_arg;
 static char partialdir_for_delayupdate[] = ".~tmp~";
 
 /** Local address to bind.  As a character string because it's
@@ -308,6 +309,7 @@ void usage(enum logcode F)
   rprintf(F,"     --force                 force deletion of directories even if not empty\n");
   rprintf(F,"     --max-delete=NUM        don't delete more than NUM files\n");
   rprintf(F,"     --max-size=SIZE         don't transfer any file larger than SIZE\n");
+  rprintf(F,"     --min-size=SIZE         don't transfer any file smaller than SIZE\n");
   rprintf(F,"     --partial               keep partially transferred files\n");
   rprintf(F,"     --partial-dir=DIR       put a partially transferred file into DIR\n");
   rprintf(F,"     --delay-updates         put all updated files into place at transfer's end\n");
@@ -361,7 +363,7 @@ void usage(enum logcode F)
 
 enum {OPT_VERSION = 1000, OPT_DAEMON, OPT_SENDER, OPT_EXCLUDE, OPT_EXCLUDE_FROM,
       OPT_FILTER, OPT_COMPARE_DEST, OPT_COPY_DEST, OPT_LINK_DEST,
-      OPT_INCLUDE, OPT_INCLUDE_FROM, OPT_MODIFY_WINDOW,
+      OPT_INCLUDE, OPT_INCLUDE_FROM, OPT_MODIFY_WINDOW, OPT_MIN_SIZE,
       OPT_READ_BATCH, OPT_WRITE_BATCH, OPT_ONLY_WRITE_BATCH, OPT_MAX_SIZE,
       OPT_REFUSED_BASE = 9000};
 
@@ -419,6 +421,7 @@ static struct poptOption long_options[] 
   {"ignore-existing",  0,  POPT_ARG_NONE,   &ignore_existing, 0, 0, 0 },
   {"ignore-non-existing",0,POPT_ARG_NONE,   &ignore_non_existing, 0, 0, 0 },
   {"max-size",         0,  POPT_ARG_STRING, &max_size_arg, OPT_MAX_SIZE, 0, 0 },
+  {"min-size",         0,  POPT_ARG_STRING, &min_size_arg, OPT_MIN_SIZE, 0, 0 },
   {"sparse",          'S', POPT_ARG_NONE,   &sparse_files, 0, 0, 0 },
   {"inplace",          0,  POPT_ARG_NONE,   &inplace, 0, 0, 0 },
   {"append",           0,  POPT_ARG_VAL,    &append_mode, 1, 0, 0 },
@@ -923,6 +926,15 @@ int parse_arguments(int *argc, const cha
 			}
 			break;
 
+		case OPT_MIN_SIZE:
+			if ((min_size = parse_size_arg(&min_size_arg, 'b')) <= 0) {
+				snprintf(err_buf, sizeof err_buf,
+					"--min-size value is invalid: %s\n",
+					min_size_arg);
+				return 0;
+			}
+			break;
+
 		case OPT_LINK_DEST:
 #ifdef HAVE_LINK
 			link_dest = 1;
@@ -1443,6 +1455,11 @@ void server_options(char **args,int *arg
 		args[ac++] = arg;
 	}
 
+	if (min_size && am_sender) {
+		args[ac++] = "--min-size";
+		args[ac++] = min_size_arg;
+	}
+
 	if (max_size && am_sender) {
 		args[ac++] = "--max-size";
 		args[ac++] = max_size_arg;
--- orig/rsync.yo	2005-10-14 18:58:31
+++ rsync.yo	2005-10-14 19:09:25
@@ -341,6 +341,7 @@ to the detailed description below for a 
      --force                 force deletion of dirs even if not empty
      --max-delete=NUM        don't delete more than NUM files
      --max-size=SIZE         don't transfer any file larger than SIZE
+     --min-size=SIZE         don't transfer any file smaller than SIZE
      --partial               keep partially transferred files
      --partial-dir=DIR       put a partially transferred file into DIR
      --delay-updates         put all updated files into place at end
@@ -812,6 +813,11 @@ be offset by one byte in the indicated d
 Examples: --max-size=1.5mt-1 is 1499999 bytes, and --max-size=2g+1 is
 2147483649 bytes.
 
+dit(bf(--min-size=SIZE)) This tells rsync to avoid transferring any
+file that is smaller than the specified SIZE, which can help in not
+transferring small, junk files.
+See the bf(--max-size) option for a description of SIZE.
+
 dit(bf(-B, --block-size=BLOCKSIZE)) This forces the block size used in
 the rsync algorithm to a fixed value.  It is normally selected based on
 the size of each file being updated.  See the technical report for details.
